signature DATATYPES = 
sig
        datatype exp = N of int
                     | R of real
                     | B of bool
                     | V of string
                     | S of string
                     | PLUS of exp*exp
                     | MINUS of exp*exp
                     | MULT of exp*exp
                     | DIV of exp*exp
                     | MOD of exp*exp
                     | AND of exp*exp
                     | OR of exp*exp
                     | NOT of exp
                     | ASMT of string*exp
                     | IMP of exp*exp
                     | EQI of exp*exp
                     | EQ of exp*exp
                     | LT of exp*exp
                     | GT of exp*exp
                     | LTE of exp*exp
                     | GTE of exp*exp
                     | STMT of exp
                     | SEQ of exp*exp
        val head : exp -> exp
        val tail : exp -> exp
end;

structure DataTypes : DATATYPES =
struct
        datatype exp = N of int
                     | R of real
                     | B of bool
                     | V of string
                     | S of string
                     | PLUS of exp*exp
                     | MINUS of exp*exp
                     | MULT of exp*exp
                     | DIV of exp*exp
                     | MOD of exp*exp
                     | AND of exp*exp
                     | OR of exp*exp
                     | NOT of exp
                     | ASMT of string*exp
                     | IMP of exp*exp
                     | EQI of exp*exp
                     | EQ of exp*exp
                     | LT of exp*exp
                     | GT of exp*exp
                     | LTE of exp*exp
                     | GTE of exp*exp
                     | STMT of exp
                     | SEQ of exp*exp
                     ;
        val head = fn (SEQ(e,_)) => e | e => e;
        val tail = fn (SEQ(_,e)) => e | e => e;
end;
