structure Parser :
sig 
	val buildast : string -> DataTypes.exp 
end =
struct
exception BuildAstError;

fun buildast (fileName) = 
    let val inStream =  TextIO.openIn fileName;
        val grab : int -> string = fn 
            n => if TextIO.endOfStream inStream 
                 then ""
                 else TextIO.inputN (inStream,n);

        fun printError (msg,line,col) = (print(fileName^"["^Int.toString line^":"^Int.toString col^"] "^msg^"\n");raise BuildAstError)

        val (tree,rem) = BuildAstParser.parse 
                     (15,
                     (BuildAstParser.makeLexer grab fileName),
                     printError,
                     fileName)
            handle BuildAstParser.ParseError => ((print "haha");raise BuildAstError);
        (* Close the source program file *)
        val _ = TextIO.closeIn inStream;
    in tree
    end
end;
